// coverage:ignore-file
import 'dart:convert';

import 'package:film_gyaan/core.dart';

/// @nodoc
class EpisodeGroups extends Result {
  EpisodeGroups({
    required this.results,
  });

  factory EpisodeGroups.fromJson(String str) => EpisodeGroups.fromMap(
        json.decode(str) as Map<String, dynamic>,
      );

  factory EpisodeGroups.fromMap(Map<String, dynamic> json) => EpisodeGroups(
        results: List<EpisodeGroupsResult>.from(
          (json['results'] as List<dynamic>? ?? <dynamic>[]).map<dynamic>(
            (dynamic x) => EpisodeGroupsResult.fromMap(
              x as Map<String, dynamic>,
            ),
          ),
        ),
      );

  List<EpisodeGroupsResult> results;

  String toJson() => json.encode(toMap());

  Map<String, dynamic> toMap() => <String, dynamic>{
        'results': List<dynamic>.from(
          results.map<dynamic>(
            (x) => x.toMap(),
          ),
        ),
      };
}

class EpisodeGroupsResult {
  EpisodeGroupsResult({
    required this.description,
    required this.episodeCount,
    required this.groupCount,
    required this.id,
    required this.name,
    required this.network,
    required this.type,
  });

  factory EpisodeGroupsResult.fromJson(String str) =>
      EpisodeGroupsResult.fromMap(
        json.decode(str) as Map<String, dynamic>,
      );

  factory EpisodeGroupsResult.fromMap(Map<String, dynamic> json) =>
      EpisodeGroupsResult(
        description: json['description'] as String? ?? '',
        episodeCount: json['episode_count'] as int? ?? 0,
        groupCount: json['group_count'] as int? ?? 0,
        id: json['id'] as String? ?? '',
        name: json['name'] as String? ?? '',
        network: Network.fromMap(
          json['network'] as Map<String, dynamic>? ?? <String, dynamic>{},
        ),
        type: json['type'] as int? ?? 0,
      );

  String description;
  int episodeCount;
  int groupCount;
  String id;
  String name;
  Network network;
  int type;

  String toJson() => json.encode(toMap());

  Map<String, dynamic> toMap() => <String, dynamic>{
        'description': description,
        'episode_count': episodeCount,
        'group_count': groupCount,
        'id': id,
        'name': name,
        'network': network.toMap(),
        'type': type,
      };
}

class Network {
  Network({
    required this.id,
    required this.logoPath,
    required this.name,
    required this.originCountry,
  });

  factory Network.fromJson(String str) => Network.fromMap(
        json.decode(str) as Map<String, dynamic>,
      );

  factory Network.fromMap(Map<String, dynamic> json) => Network(
        id: json['id'] as int? ?? 0,
        logoPath: json['logo_path'] as String? ?? '',
        name: json['name'] as String? ?? '',
        originCountry: json['origin_country'] as String? ?? '',
      );

  int id;
  String logoPath;
  String name;
  String originCountry;

  String toJson() => json.encode(toMap());

  Map<String, dynamic> toMap() => <String, dynamic>{
        'id': id,
        'logo_path': logoPath,
        'name': name,
        'origin_country': originCountry,
      };
}
